import{S as vn,i as yn,s as In,e as i,k as f,w as $,t as r,M as wn,c as a,d as n,m as c,a as s,x as P,h as l,b as p,G as e,g as y,y as D,q as x,o as S,B as k,v as $n,L as _n}from"../../../../chunks/vendor-hf-doc-builder.js";import{D as oe}from"../../../../chunks/Docstring-hf-doc-builder.js";import{C as bn}from"../../../../chunks/CodeBlock-hf-doc-builder.js";import{I as gn}from"../../../../chunks/IconCopyLink-hf-doc-builder.js";import{E as hn}from"../../../../chunks/ExampleCodeBlock-hf-doc-builder.js";function Pn(re){let d,E,h,m,I;return m=new bn({props:{code:`import requests
import torch
from PIL import Image
from io import BytesIO

from diffusers import StableDiffusionImg2ImgPipeline

device = "cuda"
model_id_or_path = "runwayml/stable-diffusion-v1-5"
pipe = StableDiffusionImg2ImgPipeline.from_pretrained(model_id_or_path, torch_dtype=torch.float16)
pipe = pipe.to(device)

url = "https://raw.githubusercontent.com/CompVis/stable-diffusion/main/assets/stable-samples/img2img/sketch-mountains-input.jpg"

response = requests.get(url)
init_image = Image.open(BytesIO(response.content)).convert("RGB")
init_image = init_image.resize((768, 512))

prompt = "A fantasy landscape, trending on artstation"

images = pipe(prompt=prompt, image=init_image, strength=0.75, guidance_scale=7.5).images
images[0].save("fantasy_landscape.png")`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> requests
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> PIL <span class="hljs-keyword">import</span> Image
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> io <span class="hljs-keyword">import</span> BytesIO

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionImg2ImgPipeline

<span class="hljs-meta">&gt;&gt;&gt; </span>device = <span class="hljs-string">&quot;cuda&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>model_id_or_path = <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe = StableDiffusionImg2ImgPipeline.from_pretrained(model_id_or_path, torch_dtype=torch.float16)
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe = pipe.to(device)

<span class="hljs-meta">&gt;&gt;&gt; </span>url = <span class="hljs-string">&quot;https://raw.githubusercontent.com/CompVis/stable-diffusion/main/assets/stable-samples/img2img/sketch-mountains-input.jpg&quot;</span>

<span class="hljs-meta">&gt;&gt;&gt; </span>response = requests.get(url)
<span class="hljs-meta">&gt;&gt;&gt; </span>init_image = Image.<span class="hljs-built_in">open</span>(BytesIO(response.content)).convert(<span class="hljs-string">&quot;RGB&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>init_image = init_image.resize((<span class="hljs-number">768</span>, <span class="hljs-number">512</span>))

<span class="hljs-meta">&gt;&gt;&gt; </span>prompt = <span class="hljs-string">&quot;A fantasy landscape, trending on artstation&quot;</span>

<span class="hljs-meta">&gt;&gt;&gt; </span>images = pipe(prompt=prompt, image=init_image, strength=<span class="hljs-number">0.75</span>, guidance_scale=<span class="hljs-number">7.5</span>).images
<span class="hljs-meta">&gt;&gt;&gt; </span>images[<span class="hljs-number">0</span>].save(<span class="hljs-string">&quot;fantasy_landscape.png&quot;</span>)`}}),{c(){d=i("p"),E=r("Examples:"),h=f(),$(m.$$.fragment)},l(o){d=a(o,"P",{});var b=s(d);E=l(b,"Examples:"),b.forEach(n),h=c(o),P(m.$$.fragment,o)},m(o,b){y(o,d,b),e(d,E),y(o,h,b),D(m,o,b),I=!0},p:_n,i(o){I||(x(m.$$.fragment,o),I=!0)},o(o){S(m.$$.fragment,o),I=!1},d(o){o&&n(d),o&&n(h),k(m,o)}}}function Dn(re){let d,E,h,m,I;return m=new bn({props:{code:`import torch
from diffusers import DiffusionPipeline
from xformers.ops import MemoryEfficientAttentionFlashAttentionOp

pipe = DiffusionPipeline.from_pretrained("stabilityai/stable-diffusion-2-1", torch_dtype=torch.float16)
pipe = pipe.to("cuda")
pipe.enable_xformers_memory_efficient_attention(attention_op=MemoryEfficientAttentionFlashAttentionOp)
# Workaround for not accepting attention shape using VAE for Flash Attention
pipe.vae.enable_xformers_memory_efficient_attention(attention_op=None)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> DiffusionPipeline
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> xformers.ops <span class="hljs-keyword">import</span> MemoryEfficientAttentionFlashAttentionOp

<span class="hljs-meta">&gt;&gt;&gt; </span>pipe = DiffusionPipeline.from_pretrained(<span class="hljs-string">&quot;stabilityai/stable-diffusion-2-1&quot;</span>, torch_dtype=torch.float16)
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe = pipe.to(<span class="hljs-string">&quot;cuda&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe.enable_xformers_memory_efficient_attention(attention_op=MemoryEfficientAttentionFlashAttentionOp)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Workaround for not accepting attention shape using VAE for Flash Attention</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe.vae.enable_xformers_memory_efficient_attention(attention_op=<span class="hljs-literal">None</span>)`}}),{c(){d=i("p"),E=r("Examples:"),h=f(),$(m.$$.fragment)},l(o){d=a(o,"P",{});var b=s(d);E=l(b,"Examples:"),b.forEach(n),h=c(o),P(m.$$.fragment,o)},m(o,b){y(o,d,b),e(d,E),y(o,h,b),D(m,o,b),I=!0},p:_n,i(o){I||(x(m.$$.fragment,o),I=!0)},o(o){S(m.$$.fragment,o),I=!1},d(o){o&&n(d),o&&n(h),k(m,o)}}}function xn(re){let d,E,h,m,I,o,b,ue,Fe,ke,q,L,ge,F,Ge,he,We,Ee,v,Be,G,Ke,He,W,Re,Je,B,Qe,Xe,K,Ye,Ze,le,et,tt,je,H,nt,R,it,Ce,M,pe,at,st,fe,ot,Ae,u,J,rt,_e,lt,pt,Q,ft,ce,ct,mt,dt,C,X,ut,be,gt,ht,O,_t,A,Y,bt,ve,vt,yt,ye,It,wt,N,Z,$t,ee,Pt,Ie,Dt,xt,St,w,te,kt,we,Et,jt,$e,Ct,At,Pe,Tt,qt,U,Lt,V,ne,Mt,De,Ot,Nt,z,ie,Ut,ae,Vt,xe,zt,Ft,Te;return o=new gn({}),F=new gn({}),J=new oe({props:{name:"class diffusers.StableDiffusionImg2ImgPipeline",anchor:"diffusers.StableDiffusionImg2ImgPipeline",parameters:[{name:"vae",val:": AutoencoderKL"},{name:"text_encoder",val:": CLIPTextModel"},{name:"tokenizer",val:": CLIPTokenizer"},{name:"unet",val:": UNet2DConditionModel"},{name:"scheduler",val:": KarrasDiffusionSchedulers"},{name:"safety_checker",val:": StableDiffusionSafetyChecker"},{name:"feature_extractor",val:": CLIPFeatureExtractor"},{name:"requires_safety_checker",val:": bool = True"}],parametersDescription:[{anchor:"diffusers.StableDiffusionImg2ImgPipeline.vae",description:`<strong>vae</strong> (<a href="/docs/diffusers/main/en/api/models#diffusers.AutoencoderKL">AutoencoderKL</a>) &#x2014;
Variational Auto-Encoder (VAE) Model to encode and decode images to and from latent representations.`,name:"vae"},{anchor:"diffusers.StableDiffusionImg2ImgPipeline.text_encoder",description:`<strong>text_encoder</strong> (<code>CLIPTextModel</code>) &#x2014;
Frozen text-encoder. Stable Diffusion uses the text portion of
<a href="https://huggingface.co/docs/transformers/model_doc/clip#transformers.CLIPTextModel" rel="nofollow">CLIP</a>, specifically
the <a href="https://huggingface.co/openai/clip-vit-large-patch14" rel="nofollow">clip-vit-large-patch14</a> variant.`,name:"text_encoder"},{anchor:"diffusers.StableDiffusionImg2ImgPipeline.tokenizer",description:`<strong>tokenizer</strong> (<code>CLIPTokenizer</code>) &#x2014;
Tokenizer of class
<a href="https://huggingface.co/docs/transformers/v4.21.0/en/model_doc/clip#transformers.CLIPTokenizer" rel="nofollow">CLIPTokenizer</a>.`,name:"tokenizer"},{anchor:"diffusers.StableDiffusionImg2ImgPipeline.unet",description:'<strong>unet</strong> (<a href="/docs/diffusers/main/en/api/models#diffusers.UNet2DConditionModel">UNet2DConditionModel</a>) &#x2014; Conditional U-Net architecture to denoise the encoded image latents.',name:"unet"},{anchor:"diffusers.StableDiffusionImg2ImgPipeline.scheduler",description:`<strong>scheduler</strong> (<a href="/docs/diffusers/main/en/api/schedulers/overview#diffusers.SchedulerMixin">SchedulerMixin</a>) &#x2014;
A scheduler to be used in combination with <code>unet</code> to denoise the encoded image latents. Can be one of
<a href="/docs/diffusers/main/en/api/schedulers/ddim#diffusers.DDIMScheduler">DDIMScheduler</a>, <a href="/docs/diffusers/main/en/api/schedulers/lms_discrete#diffusers.LMSDiscreteScheduler">LMSDiscreteScheduler</a>, or <a href="/docs/diffusers/main/en/api/schedulers/pndm#diffusers.PNDMScheduler">PNDMScheduler</a>.`,name:"scheduler"},{anchor:"diffusers.StableDiffusionImg2ImgPipeline.safety_checker",description:`<strong>safety_checker</strong> (<code>StableDiffusionSafetyChecker</code>) &#x2014;
Classification module that estimates whether generated images could be considered offensive or harmful.
Please, refer to the <a href="https://huggingface.co/runwayml/stable-diffusion-v1-5" rel="nofollow">model card</a> for details.`,name:"safety_checker"},{anchor:"diffusers.StableDiffusionImg2ImgPipeline.feature_extractor",description:`<strong>feature_extractor</strong> (<code>CLIPFeatureExtractor</code>) &#x2014;
Model that extracts features from generated images to be used as inputs for the <code>safety_checker</code>.`,name:"feature_extractor"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_img2img.py#L93"}}),X=new oe({props:{name:"__call__",anchor:"diffusers.StableDiffusionImg2ImgPipeline.__call__",parameters:[{name:"prompt",val:": typing.Union[str, typing.List[str]]"},{name:"image",val:": typing.Union[torch.FloatTensor, PIL.Image.Image] = None"},{name:"strength",val:": float = 0.8"},{name:"num_inference_steps",val:": typing.Optional[int] = 50"},{name:"guidance_scale",val:": typing.Optional[float] = 7.5"},{name:"negative_prompt",val:": typing.Union[str, typing.List[str], NoneType] = None"},{name:"num_images_per_prompt",val:": typing.Optional[int] = 1"},{name:"eta",val:": typing.Optional[float] = 0.0"},{name:"generator",val:": typing.Union[torch._C.Generator, typing.List[torch._C.Generator], NoneType] = None"},{name:"output_type",val:": typing.Optional[str] = 'pil'"},{name:"return_dict",val:": bool = True"},{name:"callback",val:": typing.Union[typing.Callable[[int, int, torch.FloatTensor], NoneType], NoneType] = None"},{name:"callback_steps",val:": typing.Optional[int] = 1"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"diffusers.StableDiffusionImg2ImgPipeline.__call__.prompt",description:`<strong>prompt</strong> (<code>str</code> or <code>List[str]</code>) &#x2014;
The prompt or prompts to guide the image generation.`,name:"prompt"},{anchor:"diffusers.StableDiffusionImg2ImgPipeline.__call__.image",description:`<strong>image</strong> (<code>torch.FloatTensor</code> or <code>PIL.Image.Image</code>) &#x2014;
<code>Image</code>, or tensor representing an image batch, that will be used as the starting point for the
process.`,name:"image"},{anchor:"diffusers.StableDiffusionImg2ImgPipeline.__call__.strength",description:`<strong>strength</strong> (<code>float</code>, <em>optional</em>, defaults to 0.8) &#x2014;
Conceptually, indicates how much to transform the reference <code>image</code>. Must be between 0 and 1. <code>image</code>
will be used as a starting point, adding more noise to it the larger the <code>strength</code>. The number of
denoising steps depends on the amount of noise initially added. When <code>strength</code> is 1, added noise will
be maximum and the denoising process will run for the full number of iterations specified in
<code>num_inference_steps</code>. A value of 1, therefore, essentially ignores <code>image</code>.`,name:"strength"},{anchor:"diffusers.StableDiffusionImg2ImgPipeline.__call__.num_inference_steps",description:`<strong>num_inference_steps</strong> (<code>int</code>, <em>optional</em>, defaults to 50) &#x2014;
The number of denoising steps. More denoising steps usually lead to a higher quality image at the
expense of slower inference. This parameter will be modulated by <code>strength</code>.`,name:"num_inference_steps"},{anchor:"diffusers.StableDiffusionImg2ImgPipeline.__call__.guidance_scale",description:`<strong>guidance_scale</strong> (<code>float</code>, <em>optional</em>, defaults to 7.5) &#x2014;
Guidance scale as defined in <a href="https://arxiv.org/abs/2207.12598" rel="nofollow">Classifier-Free Diffusion Guidance</a>.
<code>guidance_scale</code> is defined as <code>w</code> of equation 2. of <a href="https://arxiv.org/pdf/2205.11487.pdf" rel="nofollow">Imagen
Paper</a>. Guidance scale is enabled by setting <code>guidance_scale &gt; 1</code>. Higher guidance scale encourages to generate images that are closely linked to the text <code>prompt</code>,
usually at the expense of lower image quality.`,name:"guidance_scale"},{anchor:"diffusers.StableDiffusionImg2ImgPipeline.__call__.negative_prompt",description:`<strong>negative_prompt</strong> (<code>str</code> or <code>List[str]</code>, <em>optional</em>) &#x2014;
The prompt or prompts not to guide the image generation. Ignored when not using guidance (i.e., ignored
if <code>guidance_scale</code> is less than <code>1</code>).`,name:"negative_prompt"},{anchor:"diffusers.StableDiffusionImg2ImgPipeline.__call__.num_images_per_prompt",description:`<strong>num_images_per_prompt</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014;
The number of images to generate per prompt.`,name:"num_images_per_prompt"},{anchor:"diffusers.StableDiffusionImg2ImgPipeline.__call__.eta",description:`<strong>eta</strong> (<code>float</code>, <em>optional</em>, defaults to 0.0) &#x2014;
Corresponds to parameter eta (&#x3B7;) in the DDIM paper: <a href="https://arxiv.org/abs/2010.02502" rel="nofollow">https://arxiv.org/abs/2010.02502</a>. Only applies to
<a href="/docs/diffusers/main/en/api/schedulers/ddim#diffusers.DDIMScheduler">schedulers.DDIMScheduler</a>, will be ignored for others.`,name:"eta"},{anchor:"diffusers.StableDiffusionImg2ImgPipeline.__call__.generator",description:`<strong>generator</strong> (<code>torch.Generator</code>, <em>optional</em>) &#x2014;
One or a list of <a href="https://pytorch.org/docs/stable/generated/torch.Generator.html" rel="nofollow">torch generator(s)</a>
to make generation deterministic.`,name:"generator"},{anchor:"diffusers.StableDiffusionImg2ImgPipeline.__call__.output_type",description:`<strong>output_type</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;pil&quot;</code>) &#x2014;
The output format of the generate image. Choose between
<a href="https://pillow.readthedocs.io/en/stable/" rel="nofollow">PIL</a>: <code>PIL.Image.Image</code> or <code>np.array</code>.`,name:"output_type"},{anchor:"diffusers.StableDiffusionImg2ImgPipeline.__call__.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not to return a <a href="/docs/diffusers/main/en/api/pipelines/stable_diffusion/overview#diffusers.pipelines.stable_diffusion.StableDiffusionPipelineOutput">StableDiffusionPipelineOutput</a> instead of a
plain tuple.`,name:"return_dict"},{anchor:"diffusers.StableDiffusionImg2ImgPipeline.__call__.callback",description:`<strong>callback</strong> (<code>Callable</code>, <em>optional</em>) &#x2014;
A function that will be called every <code>callback_steps</code> steps during inference. The function will be
called with the following arguments: <code>callback(step: int, timestep: int, latents: torch.FloatTensor)</code>.`,name:"callback"},{anchor:"diffusers.StableDiffusionImg2ImgPipeline.__call__.callback_steps",description:`<strong>callback_steps</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014;
The frequency at which the <code>callback</code> function will be called. If not specified, the callback will be
called at every step.`,name:"callback_steps"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_img2img.py#L471",returnDescription:`
<p><a
  href="/docs/diffusers/main/en/api/pipelines/stable_diffusion/overview#diffusers.pipelines.stable_diffusion.StableDiffusionPipelineOutput"
>StableDiffusionPipelineOutput</a> if <code>return_dict</code> is True, otherwise a <code>tuple. When returning a tuple, the first element is a list with the generated images, and the second element is a list of </code>bool<code>s denoting whether the corresponding generated image likely represents "not-safe-for-work" (nsfw) content, according to the </code>safety_checker\`.</p>
`,returnType:`
<p><a
  href="/docs/diffusers/main/en/api/pipelines/stable_diffusion/overview#diffusers.pipelines.stable_diffusion.StableDiffusionPipelineOutput"
>StableDiffusionPipelineOutput</a> or <code>tuple</code></p>
`}}),O=new hn({props:{anchor:"diffusers.StableDiffusionImg2ImgPipeline.__call__.example",$$slots:{default:[Pn]},$$scope:{ctx:re}}}),Y=new oe({props:{name:"enable_attention_slicing",anchor:"diffusers.StableDiffusionImg2ImgPipeline.enable_attention_slicing",parameters:[{name:"slice_size",val:": typing.Union[str, int, NoneType] = 'auto'"}],parametersDescription:[{anchor:"diffusers.StableDiffusionImg2ImgPipeline.enable_attention_slicing.slice_size",description:`<strong>slice_size</strong> (<code>str</code> or <code>int</code>, <em>optional</em>, defaults to <code>&quot;auto&quot;</code>) &#x2014;
When <code>&quot;auto&quot;</code>, halves the input to the attention heads, so attention will be computed in two steps. If
<code>&quot;max&quot;</code>, maxium amount of memory will be saved by running only one slice at a time. If a number is
provided, uses as many slices as <code>attention_head_dim // slice_size</code>. In this case, <code>attention_head_dim</code>
must be a multiple of <code>slice_size</code>.`,name:"slice_size"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/pipelines/pipeline_utils.py#L902"}}),Z=new oe({props:{name:"disable_attention_slicing",anchor:"diffusers.StableDiffusionImg2ImgPipeline.disable_attention_slicing",parameters:[],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/pipelines/pipeline_utils.py#L918"}}),te=new oe({props:{name:"enable_xformers_memory_efficient_attention",anchor:"diffusers.StableDiffusionImg2ImgPipeline.enable_xformers_memory_efficient_attention",parameters:[{name:"attention_op",val:": typing.Optional[typing.Callable] = None"}],parametersDescription:[{anchor:"diffusers.StableDiffusionImg2ImgPipeline.enable_xformers_memory_efficient_attention.attention_op",description:`<strong>attention_op</strong> (<code>Callable</code>, <em>optional</em>) &#x2014;
Override the default <code>None</code> operator for use as <code>op</code> argument to the
<a href="https://facebookresearch.github.io/xformers/components/ops.html#xformers.ops.memory_efficient_attention" rel="nofollow"><code>memory_efficient_attention()</code></a>
function of xFormers.`,name:"attention_op"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/pipelines/pipeline_utils.py#L845"}}),U=new hn({props:{anchor:"diffusers.StableDiffusionImg2ImgPipeline.enable_xformers_memory_efficient_attention.example",$$slots:{default:[Dn]},$$scope:{ctx:re}}}),ne=new oe({props:{name:"disable_xformers_memory_efficient_attention",anchor:"diffusers.StableDiffusionImg2ImgPipeline.disable_xformers_memory_efficient_attention",parameters:[],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/pipelines/pipeline_utils.py#L877"}}),ie=new oe({props:{name:"enable_sequential_cpu_offload",anchor:"diffusers.StableDiffusionImg2ImgPipeline.enable_sequential_cpu_offload",parameters:[{name:"gpu_id",val:" = 0"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_img2img.py#L213"}}),{c(){d=i("meta"),E=f(),h=i("h1"),m=i("a"),I=i("span"),$(o.$$.fragment),b=f(),ue=i("span"),Fe=r("Image-to-Image Generation"),ke=f(),q=i("h2"),L=i("a"),ge=i("span"),$(F.$$.fragment),Ge=f(),he=i("span"),We=r("StableDiffusionImg2ImgPipeline"),Ee=f(),v=i("p"),Be=r("The Stable Diffusion model was created by the researchers and engineers from "),G=i("a"),Ke=r("CompVis"),He=r(", "),W=i("a"),Re=r("Stability AI"),Je=r(", "),B=i("a"),Qe=r("runway"),Xe=r(", and "),K=i("a"),Ye=r("LAION"),Ze=r(". The "),le=i("a"),et=r("StableDiffusionImg2ImgPipeline"),tt=r(" lets you pass a text prompt and an initial image to condition the generation of new images using Stable Diffusion."),je=f(),H=i("p"),nt=r("The original codebase can be found here: "),R=i("a"),it=r("CampVis/stable-diffusion"),Ce=f(),M=i("p"),pe=i("a"),at=r("StableDiffusionImg2ImgPipeline"),st=r(" is compatible with all Stable Diffusion checkpoints for "),fe=i("a"),ot=r("Text-to-Image"),Ae=f(),u=i("div"),$(J.$$.fragment),rt=f(),_e=i("p"),lt=r("Pipeline for text-guided image to image generation using Stable Diffusion."),pt=f(),Q=i("p"),ft=r("This model inherits from "),ce=i("a"),ct=r("DiffusionPipeline"),mt=r(`. Check the superclass documentation for the generic methods the
library implements for all the pipelines (such as downloading or saving, running on a particular device, etc.)`),dt=f(),C=i("div"),$(X.$$.fragment),ut=f(),be=i("p"),gt=r("Function invoked when calling the pipeline for generation."),ht=f(),$(O.$$.fragment),_t=f(),A=i("div"),$(Y.$$.fragment),bt=f(),ve=i("p"),vt=r("Enable sliced attention computation."),yt=f(),ye=i("p"),It=r(`When this option is enabled, the attention module will split the input tensor in slices, to compute attention
in several steps. This is useful to save some memory in exchange for a small speed decrease.`),wt=f(),N=i("div"),$(Z.$$.fragment),$t=f(),ee=i("p"),Pt=r("Disable sliced attention computation. If "),Ie=i("code"),Dt=r("enable_attention_slicing"),xt=r(` was previously invoked, this method will go
back to computing attention in one step.`),St=f(),w=i("div"),$(te.$$.fragment),kt=f(),we=i("p"),Et=r("Enable memory efficient attention as implemented in xformers."),jt=f(),$e=i("p"),Ct=r(`When this option is enabled, you should observe lower GPU memory usage and a potential speed up at inference
time. Speed up at training time is not guaranteed.`),At=f(),Pe=i("p"),Tt=r(`Warning: When Memory Efficient Attention and Sliced attention are both enabled, the Memory Efficient Attention
is used.`),qt=f(),$(U.$$.fragment),Lt=f(),V=i("div"),$(ne.$$.fragment),Mt=f(),De=i("p"),Ot=r("Disable memory efficient attention as implemented in xformers."),Nt=f(),z=i("div"),$(ie.$$.fragment),Ut=f(),ae=i("p"),Vt=r(`Offloads all models to CPU using accelerate, significantly reducing memory usage. When called, unet,
text_encoder, vae and safety checker have their state dicts saved to CPU and then are moved to a
`),xe=i("code"),zt=r("torch.device('meta') and loaded to GPU only when their specific submodule has its "),Ft=r("forward` method called."),this.h()},l(t){const g=wn('[data-svelte="svelte-1phssyn"]',document.head);d=a(g,"META",{name:!0,content:!0}),g.forEach(n),E=c(t),h=a(t,"H1",{class:!0});var se=s(h);m=a(se,"A",{id:!0,class:!0,href:!0});var Se=s(m);I=a(Se,"SPAN",{});var Wt=s(I);P(o.$$.fragment,Wt),Wt.forEach(n),Se.forEach(n),b=c(se),ue=a(se,"SPAN",{});var Bt=s(ue);Fe=l(Bt,"Image-to-Image Generation"),Bt.forEach(n),se.forEach(n),ke=c(t),q=a(t,"H2",{class:!0});var qe=s(q);L=a(qe,"A",{id:!0,class:!0,href:!0});var Kt=s(L);ge=a(Kt,"SPAN",{});var Ht=s(ge);P(F.$$.fragment,Ht),Ht.forEach(n),Kt.forEach(n),Ge=c(qe),he=a(qe,"SPAN",{});var Rt=s(he);We=l(Rt,"StableDiffusionImg2ImgPipeline"),Rt.forEach(n),qe.forEach(n),Ee=c(t),v=a(t,"P",{});var j=s(v);Be=l(j,"The Stable Diffusion model was created by the researchers and engineers from "),G=a(j,"A",{href:!0,rel:!0});var Jt=s(G);Ke=l(Jt,"CompVis"),Jt.forEach(n),He=l(j,", "),W=a(j,"A",{href:!0,rel:!0});var Qt=s(W);Re=l(Qt,"Stability AI"),Qt.forEach(n),Je=l(j,", "),B=a(j,"A",{href:!0,rel:!0});var Xt=s(B);Qe=l(Xt,"runway"),Xt.forEach(n),Xe=l(j,", and "),K=a(j,"A",{href:!0,rel:!0});var Yt=s(K);Ye=l(Yt,"LAION"),Yt.forEach(n),Ze=l(j,". The "),le=a(j,"A",{href:!0});var Zt=s(le);et=l(Zt,"StableDiffusionImg2ImgPipeline"),Zt.forEach(n),tt=l(j," lets you pass a text prompt and an initial image to condition the generation of new images using Stable Diffusion."),j.forEach(n),je=c(t),H=a(t,"P",{});var Gt=s(H);nt=l(Gt,"The original codebase can be found here: "),R=a(Gt,"A",{href:!0,rel:!0});var en=s(R);it=l(en,"CampVis/stable-diffusion"),en.forEach(n),Gt.forEach(n),Ce=c(t),M=a(t,"P",{});var Le=s(M);pe=a(Le,"A",{href:!0});var tn=s(pe);at=l(tn,"StableDiffusionImg2ImgPipeline"),tn.forEach(n),st=l(Le," is compatible with all Stable Diffusion checkpoints for "),fe=a(Le,"A",{href:!0});var nn=s(fe);ot=l(nn,"Text-to-Image"),nn.forEach(n),Le.forEach(n),Ae=c(t),u=a(t,"DIV",{class:!0});var _=s(u);P(J.$$.fragment,_),rt=c(_),_e=a(_,"P",{});var an=s(_e);lt=l(an,"Pipeline for text-guided image to image generation using Stable Diffusion."),an.forEach(n),pt=c(_),Q=a(_,"P",{});var Me=s(Q);ft=l(Me,"This model inherits from "),ce=a(Me,"A",{href:!0});var sn=s(ce);ct=l(sn,"DiffusionPipeline"),sn.forEach(n),mt=l(Me,`. Check the superclass documentation for the generic methods the
library implements for all the pipelines (such as downloading or saving, running on a particular device, etc.)`),Me.forEach(n),dt=c(_),C=a(_,"DIV",{class:!0});var me=s(C);P(X.$$.fragment,me),ut=c(me),be=a(me,"P",{});var on=s(be);gt=l(on,"Function invoked when calling the pipeline for generation."),on.forEach(n),ht=c(me),P(O.$$.fragment,me),me.forEach(n),_t=c(_),A=a(_,"DIV",{class:!0});var de=s(A);P(Y.$$.fragment,de),bt=c(de),ve=a(de,"P",{});var rn=s(ve);vt=l(rn,"Enable sliced attention computation."),rn.forEach(n),yt=c(de),ye=a(de,"P",{});var ln=s(ye);It=l(ln,`When this option is enabled, the attention module will split the input tensor in slices, to compute attention
in several steps. This is useful to save some memory in exchange for a small speed decrease.`),ln.forEach(n),de.forEach(n),wt=c(_),N=a(_,"DIV",{class:!0});var Oe=s(N);P(Z.$$.fragment,Oe),$t=c(Oe),ee=a(Oe,"P",{});var Ne=s(ee);Pt=l(Ne,"Disable sliced attention computation. If "),Ie=a(Ne,"CODE",{});var pn=s(Ie);Dt=l(pn,"enable_attention_slicing"),pn.forEach(n),xt=l(Ne,` was previously invoked, this method will go
back to computing attention in one step.`),Ne.forEach(n),Oe.forEach(n),St=c(_),w=a(_,"DIV",{class:!0});var T=s(w);P(te.$$.fragment,T),kt=c(T),we=a(T,"P",{});var fn=s(we);Et=l(fn,"Enable memory efficient attention as implemented in xformers."),fn.forEach(n),jt=c(T),$e=a(T,"P",{});var cn=s($e);Ct=l(cn,`When this option is enabled, you should observe lower GPU memory usage and a potential speed up at inference
time. Speed up at training time is not guaranteed.`),cn.forEach(n),At=c(T),Pe=a(T,"P",{});var mn=s(Pe);Tt=l(mn,`Warning: When Memory Efficient Attention and Sliced attention are both enabled, the Memory Efficient Attention
is used.`),mn.forEach(n),qt=c(T),P(U.$$.fragment,T),T.forEach(n),Lt=c(_),V=a(_,"DIV",{class:!0});var Ue=s(V);P(ne.$$.fragment,Ue),Mt=c(Ue),De=a(Ue,"P",{});var dn=s(De);Ot=l(dn,"Disable memory efficient attention as implemented in xformers."),dn.forEach(n),Ue.forEach(n),Nt=c(_),z=a(_,"DIV",{class:!0});var Ve=s(z);P(ie.$$.fragment,Ve),Ut=c(Ve),ae=a(Ve,"P",{});var ze=s(ae);Vt=l(ze,`Offloads all models to CPU using accelerate, significantly reducing memory usage. When called, unet,
text_encoder, vae and safety checker have their state dicts saved to CPU and then are moved to a
`),xe=a(ze,"CODE",{});var un=s(xe);zt=l(un,"torch.device('meta') and loaded to GPU only when their specific submodule has its "),un.forEach(n),Ft=l(ze,"forward` method called."),ze.forEach(n),Ve.forEach(n),_.forEach(n),this.h()},h(){p(d,"name","hf:doc:metadata"),p(d,"content",JSON.stringify(Sn)),p(m,"id","imagetoimage-generation"),p(m,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),p(m,"href","#imagetoimage-generation"),p(h,"class","relative group"),p(L,"id","diffusers.StableDiffusionImg2ImgPipeline"),p(L,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),p(L,"href","#diffusers.StableDiffusionImg2ImgPipeline"),p(q,"class","relative group"),p(G,"href","https://github.com/CompVis"),p(G,"rel","nofollow"),p(W,"href","https://stability.ai/"),p(W,"rel","nofollow"),p(B,"href","https://github.com/runwayml"),p(B,"rel","nofollow"),p(K,"href","https://laion.ai/"),p(K,"rel","nofollow"),p(le,"href","/docs/diffusers/main/en/api/pipelines/stable_diffusion/img2img#diffusers.StableDiffusionImg2ImgPipeline"),p(R,"href","https://github.com/CompVis/stable-diffusion/blob/main/scripts/img2img.py"),p(R,"rel","nofollow"),p(pe,"href","/docs/diffusers/main/en/api/pipelines/stable_diffusion/img2img#diffusers.StableDiffusionImg2ImgPipeline"),p(fe,"href","./text2img"),p(ce,"href","/docs/diffusers/main/en/api/diffusion_pipeline#diffusers.DiffusionPipeline"),p(C,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),p(A,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),p(N,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),p(w,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),p(V,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),p(z,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),p(u,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(t,g){e(document.head,d),y(t,E,g),y(t,h,g),e(h,m),e(m,I),D(o,I,null),e(h,b),e(h,ue),e(ue,Fe),y(t,ke,g),y(t,q,g),e(q,L),e(L,ge),D(F,ge,null),e(q,Ge),e(q,he),e(he,We),y(t,Ee,g),y(t,v,g),e(v,Be),e(v,G),e(G,Ke),e(v,He),e(v,W),e(W,Re),e(v,Je),e(v,B),e(B,Qe),e(v,Xe),e(v,K),e(K,Ye),e(v,Ze),e(v,le),e(le,et),e(v,tt),y(t,je,g),y(t,H,g),e(H,nt),e(H,R),e(R,it),y(t,Ce,g),y(t,M,g),e(M,pe),e(pe,at),e(M,st),e(M,fe),e(fe,ot),y(t,Ae,g),y(t,u,g),D(J,u,null),e(u,rt),e(u,_e),e(_e,lt),e(u,pt),e(u,Q),e(Q,ft),e(Q,ce),e(ce,ct),e(Q,mt),e(u,dt),e(u,C),D(X,C,null),e(C,ut),e(C,be),e(be,gt),e(C,ht),D(O,C,null),e(u,_t),e(u,A),D(Y,A,null),e(A,bt),e(A,ve),e(ve,vt),e(A,yt),e(A,ye),e(ye,It),e(u,wt),e(u,N),D(Z,N,null),e(N,$t),e(N,ee),e(ee,Pt),e(ee,Ie),e(Ie,Dt),e(ee,xt),e(u,St),e(u,w),D(te,w,null),e(w,kt),e(w,we),e(we,Et),e(w,jt),e(w,$e),e($e,Ct),e(w,At),e(w,Pe),e(Pe,Tt),e(w,qt),D(U,w,null),e(u,Lt),e(u,V),D(ne,V,null),e(V,Mt),e(V,De),e(De,Ot),e(u,Nt),e(u,z),D(ie,z,null),e(z,Ut),e(z,ae),e(ae,Vt),e(ae,xe),e(xe,zt),e(ae,Ft),Te=!0},p(t,[g]){const se={};g&2&&(se.$$scope={dirty:g,ctx:t}),O.$set(se);const Se={};g&2&&(Se.$$scope={dirty:g,ctx:t}),U.$set(Se)},i(t){Te||(x(o.$$.fragment,t),x(F.$$.fragment,t),x(J.$$.fragment,t),x(X.$$.fragment,t),x(O.$$.fragment,t),x(Y.$$.fragment,t),x(Z.$$.fragment,t),x(te.$$.fragment,t),x(U.$$.fragment,t),x(ne.$$.fragment,t),x(ie.$$.fragment,t),Te=!0)},o(t){S(o.$$.fragment,t),S(F.$$.fragment,t),S(J.$$.fragment,t),S(X.$$.fragment,t),S(O.$$.fragment,t),S(Y.$$.fragment,t),S(Z.$$.fragment,t),S(te.$$.fragment,t),S(U.$$.fragment,t),S(ne.$$.fragment,t),S(ie.$$.fragment,t),Te=!1},d(t){n(d),t&&n(E),t&&n(h),k(o),t&&n(ke),t&&n(q),k(F),t&&n(Ee),t&&n(v),t&&n(je),t&&n(H),t&&n(Ce),t&&n(M),t&&n(Ae),t&&n(u),k(J),k(X),k(O),k(Y),k(Z),k(te),k(U),k(ne),k(ie)}}}const Sn={local:"imagetoimage-generation",sections:[{local:"diffusers.StableDiffusionImg2ImgPipeline",title:"StableDiffusionImg2ImgPipeline"}],title:"Image-to-Image Generation"};function kn(re){return $n(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class qn extends vn{constructor(d){super();yn(this,d,kn,xn,In,{})}}export{qn as default,Sn as metadata};
